<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class modCirleLinkByCatItemList {
	var $id;
	var $title;
	var $link;
	var $access;
	var $alias;
	var $afterCircle;
}

class modCirleLinkByCat {

	const ACCESS_ALL                 = 1;
	const ACCESS_REGISTERED          = 2;
	const ACCESS_SPECIAL	         = 3;
	
	public function getSection($iId) {
		$database = &JFactory::getDBO();
		if(JRequest::getVar( 'view', 'NONE') == "frontpage"){
			return 1;
		}else if(JRequest::getVar( 'view', 'NONE') == "section"){
			return JRequest::getVar( 'id', 'NONE');
		}else if(Jrequest::getVar( 'view', 'NONE') == "category"){
			//echo 'hit category';
			$sql = "SELECT section as catid FROM #__categories WHERE id = ".$iId;
			$database->setQuery( $sql );
			$row = $database->loadResult();
			return $row;
		}else if(Jrequest::getVar( 'view', 'NONE') == "article"){
			//echo 'hit article';
			$sql = "SELECT catid FROM #__content WHERE id = ".$iId;
			$database->setQuery( $sql );
			$row = $database->loadResult();
			return $row;
		}
	}
   
	// Сохраняем копию записи - особенность работы адептера MySql
	function cloneRecord($row) {
		$item = new modCirleLinkByCatItemList();
		
		$item->id = $row->id;
		$item->title = $row->title;
		$item->link = $row->link;
		$item->access = $row->access;
		$item->alias = $row->alias;
		$item->afterCircle = $row->afterCircle;
		
		return $item;
	}
   
	// Простое получение доступа
	function getAccess($item) {
		return $item->access; 
	}

	// Проверка доступа
	function isAccessible(&$item, &$user) {
		if ($user->guest) {
			if ($this->getAccess($item) == $this::ACCESS_ALL) return true;
		} else {
			if ($this->getAccess($item) >= $this::ACCESS_ALL) return true;
		}
		return false;
	}

	// Если материал уже есть (в случае малого списка статье в категории)
	function haveInList(& $list, $id) {
		$countList = count($list);

		for ($i = 0; $i < $countList; $i++)
			if($list[$i]->id == $id)
				return true;
		
		return false;
	}
	
	public function getList($idMat, $idCat, $prevCount, $nextCount) {
		$showList = array();

		$user = JFactory::getUser();
		// Запрос получения предыдущих материалов, с учетом кольца
		$queryPrev = 
			'select id, link, title, access, alias, 0 as afterCircle
			from (
				select * from (
					select id, \'\' as link, title, access, alias 
					from #__content 
					where catid = '.$idCat.'
						and id < '.$idMat.'
						and state > 0
						and ( 
							publish_down is null 
							or publish_down >= NOW()
						)
						and ( 
							publish_up is null 
							or publish_up < NOW()
						)
					order by id desc limit 0,'.$prevCount.'
				) sort 
                order by id asc
			) a
			union
			select id, link, title, access, alias, 1 as afterCircle
			from (
				select * from (
					select id, \'\' as link, title, access, alias 
					from #__content 
					where catid = '.$idCat.'
						and id > '.$idMat.'
						and state > 0
						and ( 
							publish_down is null 
							or publish_down >= NOW()
						)
						and ( 
							publish_up is null 
							or publish_up < NOW()
						)
					order by id desc limit 0,'.$prevCount.'
				) sort 
                order by id desc
			) b
			';

		// Получаем предыдущие
		$db = & JFactory::getDBO();
		$db->setQuery($queryPrev);

		$prevList = $db->loadObjectList();
		// Массив для дополнительных элементов, которые возникают после кольца
		$prevUnshiftList = array();

		// Формируем список
		if(!empty($prevList) && count($prevList) > 0) {
			$countAddPrev = 0;
			// добавлено элементов до появления кольца
			$countAddPrevBeforeCircle = 0;
			$countPrevList = count($prevList);
			for ($i = 0; $i < $countPrevList; $i++) {
				$record = $this->cloneRecord($prevList[$i]);
				if($this->isAccessible($record, $user) && !$this->haveInList($showList, $record->id)) {
					$countAddPrev++;
					if($record->afterCircle == 0)
					{
						$countAddPrevBeforeCircle++;
						$showList[count($showList)] = $record;
					}
					else 
					{
						array_push($prevUnshiftList, $record);
					}
					if ($countAddPrev == $prevCount)
						break;
				}
			}
			
			// Если были дополнительные элементы, то замыкаем кольцо, ставя последние элементы
			if ($countAddPrevBeforeCircle < $prevCount) {
				foreach($prevUnshiftList as $itemForUnshift)
					array_unshift($showList, $itemForUnshift);
			}
		}
		
		// Запрос получения следующих материалов, с учетом кольца
		$queryNext = 
			'select id, link, title, access, alias
			from (
				select * from (
					select id, \'\' as link, title, access, alias 
					from #__content 
					where catid = '.$idCat.'
						and id > '.$idMat.'
						and state > 0
						and ( 
							publish_down is null 
							or publish_down >= NOW()
						)
						and ( 
							publish_up is null 
							or publish_up < NOW()
						)
					order by id asc limit 0,'.$nextCount.'
				) sort 
                order by id asc
			) a
			union
			select id, link, title, access, alias
			from (
				select * from (
					select id, \'\' as link, title, access, alias 
					from #__content 
					where catid = '.$idCat.'
						and id < '.$idMat.'
						and state > 0
						and ( 
							publish_down is null 
							or publish_down >= NOW()
						)
						and ( 
							publish_up is null 
							or publish_up < NOW()
						)
					order by id asc limit 0,'.$nextCount.'
				) sort 
                order by id asc
			) b
			';
		
		// Получаем следующие
		$db = & JFactory::getDBO();
		$db->setQuery($queryNext);
		$nextList = $db->loadObjectList();

		// Формируем список
		if(!empty($nextList) && count($nextList) > 0) {
			$countAddNext = 0;
			$countNextList = count($nextList);
			for ($i = 0; $i < $countNextList; $i++) {
				$record = $this->cloneRecord($nextList[$i]);
				if($this->isAccessible($record, $user) && !$this->haveInList($showList, $record->id)) {
					$countAddNext++;
					$showList[count($showList)] = $record;
					if ($countAddNext == $nextCount)
						break;
				}
			}
		}		

		// Для всех полученных элементов добавляем link
		if(count($showList) > 0) {
			$countShowList = count ($showList);
			for ($i = 0; $i < $countShowList; $i++) {
				$itemid = &JSite::getMenu()->getItems('link', 'index.php?option=com_content&view=article&id='.($showList[$i]->id), true);
				if(!empty($itemid)) {
					$showList[$i]->link = JRoute::_('index.php?Itemid='.$itemid->id);
				}
				else {
					$catitemid = JSite::getMenu()->getItems('link', 'index.php?option=com_content&view=category&id='.$idCat, true);
					if(!empty($catitemid)) {
						$showList[$i]->link = JRoute::_('index.php?option=com_content&view=article&id='.($showList[$i]->id).':'.($showList[$i]->alias).'&catid='.$idCat.'&Itemid='.$catitemid->id);
					}
					else
						$showList[$i]->link = JRoute::_('index.php?option=com_content&view=article&id='.($showList[$i]->id).':'.($showList[$i]->alias).'&catid='.$idCat);
				}
			}
		}
		
		return $showList;
	}
}
?>

